#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Aqua
#property indicator_color4  Magenta
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_width3  1
#property indicator_width4  1


//
//
//
//
//

extern int    FastPeriod      = 10;
extern int    FastPrice       = PRICE_CLOSE;
extern int    FastMethod      = MODE_EMA;
extern int    ProShift        = 2;
extern bool   ShowArrows      = false;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert.wav";

//
//
//
//
//

double fast[];
double pro[];
double UpArrow[];
double DnArrow[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
      IndicatorBuffers(5);   
      SetIndexBuffer(0,fast);
      SetIndexBuffer(1,pro);
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,trend);
      
      if (ShowArrows)
      {
         SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,233);
         SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,234);
      }
      else
      {
         SetIndexStyle(2,DRAW_NONE);
         SetIndexStyle(3,DRAW_NONE);
      }
      
      return(0);  
}  

int deinit() 
{ 
   
return(0);  
}  

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      fast[i] = iMA(NULL,0,FastPeriod,0,FastMethod,FastPrice,i);
      pro[i]  = fast[i+ProShift];
      trend[i] = trend[i+1];
         if (fast[i]>pro[i]) trend[i] = 1;
         if (fast[i]<pro[i]) trend[i] =-1;
         
         //
         //
         //
         //
         //
         
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         if (trend[i] != trend[i+1]) 
         if (trend[i] == 1) 
              UpArrow[i] = Low[i] - iATR(NULL,0,20,i)/2;
         else DnArrow[i] = High[i]+ iATR(NULL,0,20,i)/2;
         }
         
         //
         //
         //
         //
         //
          
         if (alertsOn)
         {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," 2mas ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," 2mas "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

